---
title: HTML in XMLHttpRequest
slug: Web/API/XMLHttpRequest/HTML_in_XMLHttpRequest
tags:
  - API
  - Guide
  - HTML
  - HTML with XMLHttpRequest
  - Loading HTML
  - Parsing HTML
  - Web
  - XMLHttpRequest
---
<div>{{APIRef("XMLHttpRequest")}}</div>

<p>The W3C {{domxref("XMLHttpRequest")}} specification adds <a href="/en-US/docs/Web/HTML">HTML</a> parsing support to {{domxref("XMLHttpRequest")}}, which originally supported only {{Glossary("XML")}} parsing. This feature allows Web apps to obtain an HTML resource as a parsed {{Glossary("DOM")}} using <code>XMLHttpRequest</code>.</p>

<p>To get an overview of how to use <code>XMLHttpRequest</code> in general, see <a href="/en-US/docs/Web/API/XMLHttpRequest/Using_XMLHttpRequest">Using XMLHttpRequest</a>.</p>

<h2 id="Limitations">Limitations</h2>

<p>To discourage the synchronous use of <code>XMLHttpRequest</code>, HTML support is not available in the synchronous mode. Also, HTML support is only available if the {{domxref("XMLHttpRequest.responseType", "responseType")}} property has been set to <code>"document"</code>. This limitation avoids wasting time parsing HTML uselessly when legacy code uses <code>XMLHttpRequest</code> in the default mode to retrieve {{domxref("XMLHttpRequest.responseText", "responseText")}} for <code>text/html</code> resources. Also, this limitation avoids problems with legacy code that assumes that {{domxref("XMLHttpRequest.responseXML", "responseXML")}} is <code>null</code> for HTTP error pages (which often have a <code>text/html</code> response body).</p>

<h2 id="Usage">Usage</h2>

<p>Retrieving an HTML resource as a DOM using {{domxref("XMLHttpRequest")}} works just like retrieving an XML resource as a DOM using <code>XMLHttpRequest</code>, except you can't use the synchronous mode and you have to explicitly request a document by assigning the string <code>"document"</code> to the {{domxref("XMLHttpRequest.responseType", "responseType")}} property of the <code>XMLHttpRequest</code> object after calling {{domxref("XMLHttpRequest.open", "open()")}} but before calling {{domxref("XMLHttpRequest.send", "send()")}}.</p>

<pre class="brush: js">var xhr = new XMLHttpRequest();
xhr.onload = function() {
  console.log(this.responseXML.title);
}
xhr.open("GET", "file.html");
xhr.responseType = "document";
xhr.send();
</pre>

<h2 id="Feature_detection">Feature detection</h2>

<h3 id="Method_1">Method 1</h3>

<p>This method relies on the "force async" nature of the feature. When you try to set <code>responseType</code> of an <code>XMLHttpRequest</code> object after it is opened as "sync". This throws an error in the browsers that implement the feature and works on others.</p>

<div class="line" id="LC13">
<pre class="brush: js">function HTMLinXHR() {
  if (!window.XMLHttpRequest)
    return false;
  var req = new window.XMLHttpRequest();
  req.open('GET', window.location.href, false);
  try {
    req.responseType = 'document';
  } catch(e) {
    return true;
  }
  return false;
}
</pre>
</div>

<p><a href="https://jsfiddle.net/HTcKP/1/">View on JSFiddle</a></p>

<p>This method is synchronous, does not rely on external assets though it may not be as reliable as method 2 described below since it does not check the actual feature but an indication of that feature.</p>

<h3 id="Method_2">Method 2</h3>

<p>There are two challenges to detecting exactly if a browser supports HTML parsing in {{domxref("XMLHttpRequest")}}. First, the detection result is obtained asynchronously, because HTML support is only available in the asynchronous mode. Second, you have to actually fetch a test document over HTTP, because testing with a <code>data:</code> URL would end up testing <code>data:</code> URL support at the same time.</p>

<p>Thus, to detect HTML support, a test HTML file is needed on the server. This test file is small and is not well-formed XML:</p>

<pre class="brush: js">&lt;title&gt;&amp;amp;&amp;&lt;&lt;/title&gt;</pre>

<p>If the file is named <code>detect.html</code>, the following function can be used for detecting HTML parsing support:</p>

<pre class="brush: js">function detectHtmlInXhr(callback) {
  if (!window.XMLHttpRequest) {
    window.setTimeout(function() { callback(false); }, 0);
    return;
  }
  var done = false;
  var xhr = new window.XMLHttpRequest();
  xhr.onreadystatechange = function() {
    if (this.readyState == 4 &amp;&amp; !done) {
      done = true;
      callback(!!(this.responseXML &amp;&amp; this.responseXML.title &amp;&amp; this.responseXML.title == "&amp;&amp;&lt;"));
    }
  }
  xhr.onabort = xhr.onerror = function() {
    if (!done) {
      done = true;
      callback(false);
    }
  }
  try {
    xhr.open("GET", "detect.html");
    xhr.responseType = "document";
    xhr.send();
  } catch (e) {
    window.setTimeout(function() {
      if (!done) {
        done = true;
        callback(false);
      }
    }, 0);
  }
}
</pre>

<p>The argument <code>callback</code> is a function that will be called asynchronously with <code>true</code> as the only argument if HTML parsing is supported and <code>false</code> as the only argument if HTML parsing is not supported.</p>

<p><a href="https://jsfiddle.net/xfvXR/1/">View on JSFiddle</a></p>

<h2 id="Character_encoding">Character encoding</h2>

<p>If the character encoding is declared in the HTTP {{HTTPHeader("Content-Type")}} header, that character encoding is used. Failing that, if there is a byte order mark, the encoding indicated by the byte order mark is used. Failing that, if there is a {{HTMLElement("meta")}} element that declares the encoding within the first 1024 bytes of the file, that encoding is used. Otherwise, the file is decoded as UTF-8.</p>

<h2 id="Handling_HTML_on_older_browsers">Handling HTML on older browsers</h2>

<p><code>XMLHttpRequest</code> originally supported only XML parsing. HTML parsing support is a recent addition. For older browsers, you can even use the {{domxref("XMLHttpRequest.responseText")}} property in association with <a href="/en-US/docs/Web/JavaScript/Guide/Regular_Expressions">regular expressions</a> in order to get, for example, the source code of an HTML element given its ID:</p>

<pre class="brush: js">function getHTML (oXHR, sTargetId) {
  var  rOpen = new RegExp("&lt;(?!\!)\\s*([^\\s&gt;]+)[^&gt;]*\\s+id\\=[\"\']" + sTargetId + "[\"\'][^&gt;]*&gt;" ,"i"),
       sSrc = oXHR.responseText, aExec = rOpen.exec(sSrc);

  return aExec ? (new RegExp("(?:(?:.(?!&lt;\\s*" + aExec[1] + "[^&gt;]*[&gt;]))*.?&lt;\\s*" + aExec[1] + "[^&gt;]*[&gt;](?:.(?!&lt;\\s*\/\\s*" + aExec[1] + "\\s*&gt;))*.?&lt;\\s*\/\\s*" + aExec[1] + "\\s*&gt;)*(?:.(?!&lt;\\s*\/\\s*" + aExec[1] + "\\s*&gt;))*.?", "i")).exec(sSrc.slice(sSrc.indexOf(aExec[0]) + aExec[0].length)) || "" : "";
}

var oReq = new XMLHttpRequest();
oReq.open("GET", "yourPage.html", true);
oReq.onload = function () { console.log(getHTML(this, "intro")); };
oReq.send(null);
</pre>

<div class="note"><strong>Note:</strong> This solution is very expensive for the interpreter. <strong>Use it only when it is really necessary</strong>.</div>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('XMLHttpRequest')}}</td>
   <td>{{Spec2('XMLHttpRequest')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<h3 id="XMLHttpRequest_interface"><code>XMLHttpRequest</code> interface</h3>

<p>{{Compat("api.XMLHttpRequest")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("XMLHttpRequest")}}</li>
 <li><a href="/en-US/docs/Web/API/XMLHttpRequest/Using_XMLHttpRequest">Using XMLHttpRequest</a></li>
</ul>
